<template lang="pug">
q-banner(
	v-if="noItemsAll"
	inline-actions
	rounded
	).shadow-2 В базе данных нет ни одной технологической карты
	template(#action)
		q-btn(
			color="primary",
			label="Добавить блюдо"
			:to="{name: 'kitchen-dishes-add'}"
			)
ui-table(
	v-else
	title="Технологические карты"
	:items="items"
	:columns="columns"
	:filter="filter"
	v-model:pagination="pagination"
	:loading="loading"
	@request="onRequest"
	@dblclick="onDblclick"
	)
	template(#add)
		q-btn(round , size="md" color="primary", icon="add", :to="{name: 'kitchen-techmaps-add'}").q-px-sm
			ui-tooltip Добавить новую технологическую карту

	template(#filter="props")
		q-input(outlined, dense, debounce="300", clearable, v-model="filter.query", placeholder="Найти").rounded-borders
			template(v-slot:append)
				q-icon(name="search")

	template(#action="{props}")
		q-td(:props="props")
			div.q-gutter-sm.q-td__control
				q-btn(size="md" color="primary", icon="edit", :to="{name: 'kitchen-techmaps-item', params: {id: props.row.id}}").q-px-sm
					ui-tooltip Редактировать
				q-btn(size="md" color="red", icon="delete" @click="openDeleteDialog(props.row)").q-px-sm
					ui-tooltip Удалить

q-dialog(v-model="deleteConfirm.model", persistent)
	q-card
		q-card-section.row.items-center
			q-avatar(icon="delete_forever", color="negative", text-color="white")
			span.q-ml-sm Вы уверены что хотите удалить карту «{{ deleteConfirm.item.name }}»
		q-card-actions(align="right")
			q-btn(flat, label="Отмена", color="primary", v-close-popup)
			q-btn(flat, label="Удалить", color="negative", v-close-popup, @click="deleteItem(deleteConfirm.item.id)")

</template>

<script lang="ts">
	import UiTooltip from '@/components/ui/UiTooltip.vue'
	import UiTable from '@/components/ui/UiTable.vue'
	import { ITechMap } from '@/plugins/utils/types'
	import { computed, defineComponent, onMounted, ref, reactive } from 'vue'
	import { useKitchenTechMapsStore } from '@/pages/kitchen/children/techmaps/store'
	import { useRouter } from 'vue-router'

	export default defineComponent({
		name: 'TableKitchenTechMaps',

		components: { UiTable, UiTooltip },

		setup() {
			const store = useKitchenTechMapsStore()
			const router = useRouter()

			const filter = reactive({
				query: store.filterOptions.search,
			})

			const noItemsAll = computed(() => store.noItemsAll)

			const deleteConfirm = reactive({
				model: false,
				item: {},
			})

			const items = computed(() => store.items)

			const loading = computed(() => store.loading)

			const pagination = computed({
				get() {
					return {
						sortBy: store.filterOptions.orderField,
						descending: store.filterOptions.sortDesc,
						page: store.filterOptions.page,
						rowsPerPage: store.filterOptions.size,
						rowsNumber: store.totalSize,
						totalPages: Math.ceil((store.totalSize || store.filterOptions.page) / store.filterOptions.page),
					}
				},
				set(val) {
					// no action
				},
			})

			onMounted(() => {
				store.getAllTechMaps()
			})

			return {
				noItemsAll,
				items,
				filter,
				pagination,
				loading,
				columns: [
					{
						name: 'id',
						required: true,
						label: 'ID',
						align: 'left',
						field: 'id',
						sortable: true,
					},
					{
						name: 'name',
						required: true,
						label: 'Название',
						align: 'left',
						field: 'name',
						sortable: true,
					},
					{
						name: 'fats',
						required: true,
						label: 'Жиры',
						align: 'left',
						field: 'fats',
						sortable: true,
					},
					{
						name: 'calories',
						required: true,
						label: 'Калории',
						align: 'left',
						field: 'calories',
						sortable: true,
					},
					{
						name: 'carbohydrates',
						required: true,
						label: 'Углеводы',
						align: 'left',
						field: 'carbohydrates',
						sortable: true,
					},
					{
						name: 'proteins',
						required: true,
						label: 'Протеины',
						align: 'left',
						field: 'proteins',
						sortable: true,
					},
				],
				onDblclick(row: ITechMap) {
					if (row?.id) router.push({ name: 'kitchen-techmaps-item', params: { id: row.id } })
				},
				onRequest(opts: Record<string, any>) {
					store.$patch((state) => {
						state.filterOptions.search = opts.filter.query
						state.filterOptions.page = opts.pagination.page
						state.filterOptions.orderField = opts.pagination.sortBy
						state.filterOptions.sortDesc = opts.pagination.descending
						state.filterOptions.size = opts.pagination.rowsPerPage
					})
					store.getAllTechMaps()
				},
				deleteConfirm,
				openDeleteDialog(item: ITechMap) {
					deleteConfirm.item = item
					deleteConfirm.model = true
				},
				deleteItem(id: number) {
					store.deleteTechMapItem(id)
				},
			}
		},
	})
</script>
